// 002 p_genc_406_constructor
// 04 jan 2008

// -- (C) Felix John COLIBRI 2008
// -- documentation: http://www.felix-colibri.com

(*$r+*)
{$APPTYPE CONSOLE}

program p_genc_406_constructor;
  uses
  u_c_genc_406_factory in 'u_c_genc_406_factory.pas';

  // -- c_integer_base

  type c_integer_base=
           Class( c_base<System.Int32> )
             public
               m_value_1: String;

               constructor Create;
               procedure initialize_base(p_data: System.Int32); Override;
               function ToString: String; Override;
           end; // c_integer_base

  constructor c_integer_base.Create;
    begin
      Inherited;
    end; // Create
    
  procedure c_integer_base.initialize_base(p_data: System.Int32);
    begin
      Inherited;
      m_value_1:= '111';
    end; // initialize_base

  function c_integer_base.ToString: String;
    begin
      Result:= Inherited ToString+ ' '+ m_value_1.ToString;
    end; // ToString

  procedure create_integer_base;
    var l_c_integer_base: c_base<System.Int32>;
    begin
      l_c_integer_base:= c_factory<System.Int32, c_integer_base>.f_c_create_base(123);
      writeln(l_c_integer_base.ToString);
    end; // create_integer_base

  // -- c_person_base

  type c_person=
           Class
             m_first_name: String;
             Constructor Create;
             constructor create_person(p_first_name: String);
             function ToString: String; Override;
           end; // c_person

  constructor c_person.create;
    begin
      Inherited Create;
    end; // create

  constructor c_person.create_person(p_first_name: String);
    begin
      Inherited Create;
      m_first_name:= p_first_name;
    end; // create_person

  function c_person.ToString: String;
    begin
      Result:= m_first_name;
    end; // ToString

  type c_person_base=
           Class( c_base<c_person> )
             public
               m_value_1: Double;

               Constructor Create;
               procedure initialize_base(p_data: c_person); Override;
               function ToString: String; Override;
           end; // c_person_base

  Constructor c_person_base.Create;
    begin
      Inherited;
    end; // Create

  procedure c_person_base.initialize_base(p_data: c_person);
    begin
      Inherited;
      m_value_1:= 3.14;
    end; // initialize_base

  function c_person_base.ToString: String;
    begin
      Result:= Inherited ToString+ ' '+ m_value_1.ToString;
    end; // ToString

  procedure create_person_base;
    var l_c_person_base: c_base<c_person>;
    begin
      l_c_person_base:= c_factory<c_person, c_person_base>.f_c_create_base( c_person.create_person('Joe') );
      writeln(l_c_person_base.ToString);
    end; // create_person_base

  begin // main
    create_integer_base;
    writeln;
    create_person_base;

    write('type enter'); Readln;
  end. // main


