// 002 u_c_genc_406_factory
// 03 jan 2008

// -- (C) Felix John COLIBRI 2008
// -- documentation: http://www.felix-colibri.com

(*$r+*)

unit u_c_genc_406_factory;
  interface

    type c_base<T_data>=
           class
             m_data: T_data;

             procedure initialize_base(p_data: T_data); Virtual;
             function ToString: String; Override;
           end; // c_base

         c_factory<T_data; B_base: c_base <T_data>, Constructor >=
           class
             class function f_c_create_base(p_data: T_data): B_base;
           end; // c_factory

  implementation

    // -- c_base<T_data>

    procedure c_base<T_data>.initialize_base(p_data: T_data);
      begin
        writeln('initialize '+ Self.ClassName+ ' with '+ p_data.ToString);
        m_data:= p_data;
      end; // initialize_base

    function c_base<T_data>.ToString: String;
      begin
        Result:= m_data.ToString;
      end; // ToString

    // -- c_factory

    Class Function c_factory<T_data, B_base>.f_c_create_base(p_data: T_data): B_base;
      begin
        Result:= B_base.Create;
        Result.initialize_base(p_data);
      end; // create_factory

    begin // u_c_factory
    end. // u_c_factory


